import 'package:dyte_core_platform_interface/dyte_core_platform_interface.dart';

DyteClientPlatform get _platform => DyteClientPlatform.instance;

class DyteMobileClient {
  void init(DyteMeetingInfo meetingInfo) => _platform.init(meetingInfo);

  void joinRoom() => _platform.joinRoom();

  void leaveRoom() => _platform.leaveRoom();

  DyteRoomParticipants get participants => _platform.particpants;

  Stream<List<DyteMeetingParticipant>> get activeStream =>
      _platform.activeStream;

  Stream<DyteRoomParticipants> get participantsStream =>
      _platform.particpantsStream;

  void closeParticipantsStream() => _platform.closeParticipantsStream();

  void addMeetingRoomEventsListener(
          DyteMeetingRoomEventsListener meetingRoomEventsListener) =>
      _platform.addMeetingRoomEventsListener(meetingRoomEventsListener);

  void removeMeetingRoomEventsListener(
          DyteMeetingRoomEventsListener meetingRoomEventsListener) =>
      _platform.removeMeetingRoomEventsListener(meetingRoomEventsListener);

  void addParticipantEventsListener(
          DyteParticipantEventsListener participantEventsListener) =>
      _platform.addParticipantEventListener(participantEventsListener);

  DyteLocalUser get localUser => _platform.localUser;

  void addSelfEventsListener(DyteSelfEventsListener dyteSelfListener) =>
      _platform.addDyteSelfParticipantListener(dyteSelfListener);

  Future<void> addPluginEventsListener(
          DytePluginEventsListener pluginEventsListener) =>
      _platform.addPluginEventsListener(pluginEventsListener);

  Future<void> removePluginEventsListener(
          DytePluginEventsListener pluginEventsListener) =>
      _platform.removePluginEventsListener(pluginEventsListener);

  Future<void> setPage(int pageNumber) => _platform.setPage(pageNumber);

  DyteRecording get recording => _platform.recording;

  void pin(DyteMeetingParticipant participant) => _platform.pin(participant);

  void unpin() => _platform.unpin();

  DytePoll get polls => _platform.polls;

  DyteChat get chat => _platform.chat;

  DytePlugins get plugins => _platform.plugins;
}
